-- 
-- Greifer Script by sdfkz
--


greiferfurca = {};

function greiferfurca.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function greiferfurca:load(xmlFile)

        local Collision1 = {};
	Collision1.collision = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.collision1#collision"));
	Collision1.collisionAttacher = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.collision1#collsionAttacher"));
	Collision1.armAttacher = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.collision1#armAttacher"));
	Collision1.index = 0;
	self.Collision1Base = Collision1;
	
	local Collision2 = {};
	Collision2.collision = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.collision2#collision"));
	Collision2.collisionAttacher = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.collision2#collsionAttacher"));
	Collision2.armAttacher = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.collision2#armAttacher"));
	Collision2.index = 0;
	self.Collision2Base = Collision2;

	self.collisions = true;        

  local rotationNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation1#index"));
    if rotationNode1 ~= nil then
        self.rotation1 = {};
        self.rotation1.node = rotationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#minRot"));
        self.rotation1.minRot = {};
        self.rotation1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#maxRot"));
        self.rotation1.maxRot = {};
        self.rotation1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotation1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#rotTime"), 2)*1000;
        self.rotation1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#touchRotLimit"), 10));
    end;
	
	local rotationNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation2#index"));
    if rotationNode2 ~= nil then
        self.rotation2 = {};
        self.rotation2.node = rotationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#minRot"));
        self.rotation2.minRot = {};
        self.rotation2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#maxRot"));
        self.rotation2.maxRot = {};
        self.rotation2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotation2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#rotTime"), 2)*1000;
        self.rotation2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#touchRotLimit"), 10));
    end;

    local rotationNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation3#index"));
    if rotationNode3 ~= nil then
        self.rotation3 = {};
        self.rotation3.node = rotationNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#minRot"));
        self.rotation3.minRot = {};
        self.rotation3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#maxRot"));
        self.rotation3.maxRot = {};
        self.rotation3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotation3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation3#rotTime"), 2)*1000;
        self.rotation3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation3#touchRotLimit"), 10));
    end;
     local hydraulic = getXMLString(xmlFile, "vehicle.hydraulic#indexHydraulic");
	if hydraulic ~= nil then
		self.hydraulic = {};
		self.hydraulic.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulic#indexHydraulic"));
		self.hydraulic.punch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulic#indexPunch"));
		self.hydraulic.translationPunch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulic#translationPunch"));
		local ax, ay, az = getWorldTranslation(self.hydraulic.punch);
		local bx, by, bz = getWorldTranslation(self.hydraulic.translationPunch);
		self.hydraulic.punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		
                self.hydraulic4 = {};
		self.hydraulic4.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulic4#indexHydraulic"));
		self.hydraulic4.punch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulic4#indexPunch"));
		self.hydraulic4.translationPunch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulic4#translationPunch"));
		local ax, ay, az = getWorldTranslation(self.hydraulic4.punch);
		local bx, by, bz = getWorldTranslation(self.hydraulic4.translationPunch);
		self.hydraulic4.punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
       

        self.keys = {};
	self.keysDesc = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
		self.keysDesc[inputName] = getXMLString(xmlFile, baseName.. "#keyDesc");
        i = i+1;
    end;	
   

                self.hydraulicPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulic#hydraulicPoint"));
                self.hydraulicPoint4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulic4#hydraulicPoint4"));
    end;

        
	hydraulicSoundFile = Utils.getFilename("sounds/hydraRot.wav", self.baseDirectory);
    self.hydraulicSoundId = createSample("hydraulicSound");
    loadSample(self.hydraulicSoundId, hydraulicSoundFile, false);
    self.hydraulicPlaying = false;
	self.hydraulicSoundAllow = false;	
end;
          
function greiferfurca:delete()
end;

function greiferfurca:mouseEvent(posX, posY, isDown, isUp, button)
end;

function greiferfurca:keyEvent(unicode, sym, modifier, isDown)

        if sym == Input.KEY_g then
		self.rotation1Max = isDown;
	end;
        if sym == Input.KEY_v then
		self.rotation1Min = isDown;
	end;
         if sym == Input.KEY_h then
		self.rotation2Max = isDown;
	end;
        if sym == Input.KEY_b then
		self.rotation2Min = isDown;
	end;
         if sym == Input.KEY_y then
		self.rotation3Max = isDown;
	end;
        if sym == Input.KEY_u then
		self.rotation3Min = isDown;
	end;
         if isDown then
		if sym == Input.KEY_g or sym == Input.KEY_v or sym == Input.KEY_h or sym == Input.KEY_b or sym == Input.KEY_y or sym == Input.KEY_u then
		    self.hydraulicSoundAllow = true;
		end;
	else
		self.hydraulicSoundAllow = false;
	end;
end;
function greiferfurca:update(dt)
		
        local CollisionBase1 = self.Collision1Base;
		setJointFrame(CollisionBase1.index, 0, CollisionBase1.armAttacher);
		local CollisionBase2 = self.Collision2Base;
		setJointFrame(CollisionBase2.index, 0, CollisionBase2.armAttacher);

	    if self.collisions then
			self.collisions = false;
			local constr = JointConstructor:new();
			constr:setActors(self.rootNode, self.Collision1Base.collision);
			constr:setJointTransforms(self.Collision1Base.armAttacher, self.Collision1Base.collisionAttacher);
			for i=1, 3 do
				constr:setRotationLimit(i-1, 0, 0, 0);
				constr:setTranslationLimit(i-1, true, 0, 0);
			end;
			self.Collision1Base.index = constr:finalize();

			local constr2 = JointConstructor:new();
			constr2:setActors(self.rootNode, self.Collision2Base.collision);
			constr2:setJointTransforms(self.Collision2Base.armAttacher, self.Collision2Base.collisionAttacher);
			for i=1, 3 do
				constr2:setRotationLimit(i-1, 0, 0, 0);
				constr2:setTranslationLimit(i-1, true, 0, 0);
			end;
			self.Collision2Base.index = constr2:finalize();
		end;




        local doRotate = self.rotation1Max or self.rotation1Min 
	if self.rotation1 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation1.maxRot, self.rotation1.minRot, 3, self.rotation1.rotTime, dt, not self.rotation1Max);
        setRotation(self.rotation1.node, unpack(newRot));
		if self.hydraulicSoundAllow and not self.hydraulicPlaying then
			playSample(self.hydraulicSoundId,0,1,0);
			self.hydraulicPlaying = true;
		end;
	elseif not self.hydraulicSoundAllow and self.hydraulicPlaying then
		stopSample(self.hydraulicSoundId);
		self.hydraulicPlaying = false;
	end;	
	local doRotate = self.rotation2Max or self.rotation2Min 
	if self.rotation2 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation2.maxRot, self.rotation2.minRot, 3, self.rotation2.rotTime, dt, not self.rotation2Max);
        setRotation(self.rotation2.node, unpack(newRot));
		if self.hydraulicSoundAllow and not self.hydraulicPlaying then
			playSample(self.hydraulicSoundId,0,1,0);
			self.hydraulicPlaying = true;
		end;
	elseif not self.hydraulicSoundAllow and self.hydraulicPlaying then
		stopSample(self.hydraulicSoundId);
		self.hydraulicPlaying = false;
	end;	
        local doRotate = self.rotation3Max or self.rotation3Min 
	if self.rotation3 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation3.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation3.maxRot, self.rotation3.minRot, 3, self.rotation3.rotTime, dt, not self.rotation3Max);
        setRotation(self.rotation3.node, unpack(newRot));
		if self.hydraulicSoundAllow and not self.hydraulicPlaying then
			playSample(self.hydraulicSoundId,0,1,0);
			self.hydraulicPlaying = true;
		end;
	elseif not self.hydraulicSoundAllow and self.hydraulicPlaying then
		stopSample(self.hydraulicSoundId);
		self.hydraulicPlaying = false;
	end;	
        
        if self.hydraulic ~= nil then
		local ax, ay, az = getWorldTranslation(self.hydraulic.node);
		local bx, by, bz = getWorldTranslation(self.hydraulicPoint);
		local x, y, z = worldDirectionToLocal(getParent(self.hydraulic.node), bx-ax, by-ay, bz-az);
		setDirection(self.hydraulic.node, x*-1, y*-1, z*-1, 0, 0, 1);
		if self.hydraulic.punch ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.hydraulic.punch, 0, 0, (distance-self.hydraulic.punchDistance)*-1);
		end;
	end;
	if self.hydraulic4 ~= nil then
		local ax, ay, az = getWorldTranslation(self.hydraulic4.node);
		local bx, by, bz = getWorldTranslation(self.hydraulicPoint4);
		local x, y, z = worldDirectionToLocal(getParent(self.hydraulic4.node), bx-ax, by-ay, bz-az);
		setDirection(self.hydraulic4.node, x*-1, y*-1, z*-1, 0, 0, 1);
		if self.hydraulic4.punch ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.hydraulic4.punch, 0, 0, (distance-self.hydraulic4.punchDistance)*-1);
		end;

       end;
function greiferfurca:draw()
end;

function greiferfurca:validateAttacherJoint(implement, jointDesc, dt)
    return true;
       end; 
end;        
  